    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.flow.planner;
    022
    023import java.util.Set;
    024
    025import cascading.property.ConfigDef;
    026import cascading.tuple.Fields;
    027
    028/**
    029 *
    030 */
    031public interface ScopedElement
    032  {
    033  /**
    034   * Method outgoingScopeFor returns the Scope this FlowElement hands off to the next FlowElement.
    035   *
    036   * @param incomingScopes of type Set<Scope>
    037   * @return Scope
    038   */
    039  Scope outgoingScopeFor( Set<Scope> incomingScopes );
    040
    041  /**
    042   * Method resolveIncomingOperationArgumentFields returns the Fields outgoing from the previous FlowElement that
    043   * are consumable by this FlowElement when preparing Operation arguments.
    044   *
    045   * @param incomingScope of type Scope
    046   * @return Fields
    047   */
    048  Fields resolveIncomingOperationArgumentFields( Scope incomingScope );
    049
    050  /**
    051   * Method resolveIncomingOperationPassThroughFields returns the Fields outgoing from the previous FlowElement that
    052   * are consumable by this FlowElement when preparing the Pipe outgoing tuple.
    053   *
    054   * @param incomingScope of type Scope
    055   * @return Fields
    056   */
    057  Fields resolveIncomingOperationPassThroughFields( Scope incomingScope );
    058
    059  ConfigDef getConfigDef();
    060
    061  boolean hasConfigDef();
    062
    063  ConfigDef getNodeConfigDef();
    064
    065  boolean hasNodeConfigDef();
    066
    067  ConfigDef getStepConfigDef();
    068
    069  boolean hasStepConfigDef();
    070  }